# frozen_string_literal: true

require 'nokogiri'

Facter.add(:iis_apppools) do
  # # windows only
  confine kernel: :windows

  powershell = File.exist?("#{ENV['SYSTEMROOT']}\\system32\\windowspowershell\\v1.0\\powershell.exe") ? "#{ENV['SYSTEMROOT']}\\system32\\windowspowershell\\v1.0\\powershell.exe" : 'powershell.exe'

  def process_iis_site_xml(result)
    # an array to store feature hashes
    pools = []

    # create the XML document and parse the objects
    doc = Nokogiri::XML(result)

    doc.xpath('/Objects/Object').each do |object|
      name = object.xpath("./Property[@Name='Name']").text
      state = object.xpath("./Property[@Name='State']").text

      # put name and state into a hash
      pool_hash = {
        name: name,
        state: state,
      }

      # push hash to feature array
      pools.push(pool_hash)
    end

    pools
  end

  setcode do
    pool_xml = Facter::Core::Execution.exec(%(#{powershell} C:/tmp/GetAppPools.ps1))

    process_iis_site_xml(pool_xml)
  end
end
