# frozen_string_literal: true

require 'nokogiri'

Facter.add(:iis_apps) do
  # # windows only
  confine kernel: :windows

  powershell = File.exist?("#{ENV['SYSTEMROOT']}\\system32\\windowspowershell\\v1.0\\powershell.exe") ? "#{ENV['SYSTEMROOT']}\\system32\\windowspowershell\\v1.0\\powershell.exe" : 'powershell.exe'

  def process_iis_app_xml(result)
    # an array toS store feature hashes
    apps = []

    # create the XML document and parse the objects
    doc = Nokogiri::XML(result)

    doc.xpath('/Objects/Object').each do |object|
      site = object.xpath("./Property[@Name='Site']").text
      name = object.xpath("./Property[@Name='Name']").text
      physical_path = object.xpath("./Property[@Name='PhysicalPath']").text

      # put name and state into a hash
      site_hash = {
        site: site,
        name: name,
        physical_path: physical_path,
      }

      # push hash to feature array
      apps.push(site_hash)
    end

    apps
  end

  setcode do
    site_xml = Facter::Core::Execution.exec(%(#{powershell} C:/tmp/GetWebApplications.ps1))

    process_iis_app_xml(site_xml)
  end
end
