# frozen_string_literal: true

require 'nokogiri'

Facter.add(:iis_sites) do
  # # windows only
  confine kernel: :windows

  powershell = File.exist?("#{ENV['SYSTEMROOT']}\\system32\\windowspowershell\\v1.0\\powershell.exe") ? "#{ENV['SYSTEMROOT']}\\system32\\windowspowershell\\v1.0\\powershell.exe" : 'powershell.exe'

  def process_iis_site_xml(result)
    # an array to store feature hashes
    sites = []

    # create the XML document and parse the objects
    doc = Nokogiri::XML(result)

    doc.xpath('/Objects/Object').each do |object|
      name = object.xpath("./Property[@Name='Name']").text
      id = object.xpath("./Property[@Name='ID']").text
      state = object.xpath("./Property[@Name='State']").text
      physical_path = object.xpath("./Property[@Name='PhysicalPath']").text

      # put name and state into a hash
      site_hash = {
        name: name,
        id: id,
        state: state,
        physical_path: physical_path,
      }

      # push hash to feature array
      sites.push(site_hash)
    end

    sites
  end

  setcode do
    site_xml = Facter::Core::Execution.exec(%(#{powershell} C:/tmp/GetIISSites.ps1))

    process_iis_site_xml(site_xml)
  end
end
