# @summary A short summary of the purpose of this class
#
# A description of what this class does
#
# @example
#   include secure_iis_cis::cis_1_2
class secure_iis_cis::cis_1_2(
  Boolean $enforced = true,
) {

  file { 'C:/tmp/GetNonHostHeaderSites.ps1':
    ensure  => file,
    content => file('secure_iis_cis/GetNonHostHeaderSites.ps1'),
  }

  if($enforced) {
    # This rule cannot be enforced; only reported
    $facts['missing_host_headers'].each | Hash $header | {
      $application = $header['ApplicationName']

      notify { "${application} is not bound to an http site.": }

      # exec { "Delete ${application}":
      #   command  => "Remove-IISSite -Name \"${application}\" -Confirm:\$false",
      #   provider => powershell,
      # }
    }
  }
}
