# @summary A short summary of the purpose of this class
#
# A description of what this class does
#
# @example
#   include secure_iis_cis::cis_2_3
class secure_iis_cis::cis_2_3(
  Boolean $enforced = true,
) {
  if($enforced) {
    exec { 'Require SSL forms authentication for server':
      command  => "Set-WebConfigurationProperty -pspath 'MACHINE/WEBROOT/APPHOST' -filter 'system.web/authentication/forms' -name 'requireSSL' -value 'True'",
      unless   => "if ((Get-WebConfigurationProperty -pspath 'MACHINE/WEBROOT/APPHOST' -filter 'system.web/authentication/forms' -name 'requireSSL') -ne 'True') { exit 1 }",
      provider => powershell,
    }

    $facts['iis_sites'].each | Hash $site | {
      exec { "Require SSL forms authentication for site ${site['name']}":
        command  => "Set-WebConfigurationProperty -pspath 'MACHINE/WEBROOT/APPHOST/${site['name']}' -filter 'system.web/authentication/forms' -name 'requireSSL' -value 'True'",
        unless   => "if ((Get-WebConfigurationProperty -pspath 'MACHINE/WEBROOT/APPHOST/${site['name']}' -filter 'system.web/authentication/forms' -name 'requireSSL') -ne 'True') { exit 1 }",
        provider => powershell,
      }
    }

    $facts['iis_apps'].each | Hash $app | {
      exec { "Require SSL forms authentication for app ${app['name']}":
        command  => "Set-WebConfigurationProperty -pspath 'MACHINE/WEBROOT/APPHOST/${app['site']}${app['name']}' -filter 'system.web/authentication/forms' -name 'requireSSL' -value 'True'",
        unless   => "if ((Get-WebConfigurationProperty -pspath 'MACHINE/WEBROOT/APPHOST/${app['site']}${app['name']}' -filter 'system.web/authentication/forms' -name 'requireSSL') -ne 'True') { exit 1 }",
        provider => powershell,
      }
    }
  }
}
