# @summary A short summary of the purpose of this class
#
# A description of what this class does
#
# @example
#   include secure_iis_cis::cis_2_4
class secure_iis_cis::cis_2_4(
  Boolean $enforced = true,
) {
  if($enforced) {
    exec { 'Require forms authentication set to cookies for server':
      command  => "Set-WebConfigurationProperty -pspath 'MACHINE/WEBROOT/APPHOST' -filter 'system.web/authentication/forms' -name 'cookieless' -value 'UseCookies'",
      unless   => "if ((Get-WebConfigurationProperty -pspath 'MACHINE/WEBROOT/APPHOST' -filter 'system.web/authentication/forms' -Recurse -name 'cookieless') -ne 'UseCookies') { exit 1 }",
      provider => powershell,
    }

    $facts['iis_sites'].each | Hash $site | {
      exec { "Require forms authentication set to cookies for site ${site['name']}":
        command  => "Set-WebConfigurationProperty -pspath 'MACHINE/WEBROOT/APPHOST/${site['name']}' -filter 'system.web/authentication/forms' -name 'cookieless' -value 'UseCookies'",
        unless   => "if ((Get-WebConfigurationProperty -pspath 'MACHINE/WEBROOT/APPHOST/${site['name']}' -filter 'system.web/authentication/forms' -Recurse -name 'cookieless') -ne 'UseCookies') { exit 1 }",
        provider => powershell,
      }
    }

    $facts['iis_apps'].each | Hash $app | {
      exec { "Require forms authentication set to cookies for app ${app['name']}":
        command  => "Set-WebConfigurationProperty -pspath 'MACHINE/WEBROOT/APPHOST/${app['site']}${app['name']}' -filter 'system.web/authentication/forms' -name 'cookieless' -value 'UseCookies'",
        unless   => "if ((Get-WebConfigurationProperty -pspath 'MACHINE/WEBROOT/APPHOST/${app['site']}${app['name']}' -filter 'system.web/authentication/forms' -Recurse -name 'cookieless') -ne 'UseCookies') { exit 1 }",
        provider => powershell,
      }
    }
  }
}
