# @summary A short summary of the purpose of this class
#
# A description of what this class does
#
# @example
#   include secure_iis_cis::cis_3_7
class secure_iis_cis::cis_3_7(
  Boolean $enforced = true,
) {
  if($enforced) {
    exec { 'Set HTTP only cookies for server':
      command  => "Set-WebConfigurationProperty -pspath 'MACHINE/WEBROOT/APPHOST' -filter 'system.web/httpCookies' -name 'httpOnlyCookies' -value 'True'",
      unless   => "if ((Get-WebConfigurationProperty -pspath 'MACHINE/WEBROOT/APPHOST' -filter 'system.web/httpCookies' -name 'httpOnlyCookies') -ne 'True') { exit 1 }",
      provider => powershell,
    }

    $facts['iis_sites'].each | Hash $site | {
      exec { "Set HTTP only cookies for site ${site['name']}":
        command  => "Set-WebConfigurationProperty -pspath 'MACHINE/WEBROOT/APPHOST/${site['name']}' -filter 'system.web/httpCookies' -name 'httpOnlyCookies' -value 'True'",
        unless   => "if ((Get-WebConfigurationProperty -pspath 'MACHINE/WEBROOT/APPHOST/${site['name']}' -filter 'system.web/httpCookies' -name 'httpOnlyCookies') -ne 'True') { exit 1 }",
        provider => powershell,
      }
    }

    $facts['iis_apps'].each | Hash $app | {
      exec { "Set HTTP only cookies for site ${app['name']}":
        command  => "Set-WebConfigurationProperty -pspath 'MACHINE/WEBROOT/APPHOST/${app['site']}${app['name']}' -filter 'system.web/httpCookies' -name 'httpOnlyCookies' -value 'True'",
        unless   => "if ((Get-WebConfigurationProperty -pspath 'MACHINE/WEBROOT/APPHOST/${app['site']}${app['name']}' -filter 'system.web/httpCookies' -name 'httpOnlyCookies') -ne 'True') { exit 1 }",
        provider => powershell,
      }
    }
  }
}
